
/*
  Soft pour la gestion de boutons et joysticks
  My HumanKit
  07/03/2018
  Christian Fromentin
  fromentin.christian@gmail.com

*/

// affectation des broches d'entrees analogique
const int ana_inPin1 = A1;  // Analog input pin bouton 1
const int ana_inPin2 = A2;  // Analog input pin bouton 2
const int ana_inPin3 = A3;  // Analog input pin bouton 3
const int ana_inPin4 = A4;  // Analog input pin bouton 4
const int Joy_inPin1 = A5;  // Analog input X-Up
const int Joy_inPin2 = A6;  // Analog input X-Down
const int Joy_inPin3 = A7;  // Analog input Y-Up
const int Joy_inPin4 = A8;  // Analog input Y-Down

// variable pour la mémorisation des maxi bouton
int off_ana_1; // position relachée
int off_ana_2; // position relachée
int off_ana_3; // position relachée
int off_ana_4; // position relachée
// variable pour la mémorisation des maxis joystck
int off_Joy_1; // position relachée
int off_Joy_2; // position relachée
int off_Joy_3; // position relachée
int off_Joy_4; // position relachée
// variable pour la mémoristion de mini
int on_ana_1; // position appuyé
int on_ana_2; // position appuyé
int on_ana_3; // position appuyé
int on_ana_4; // position appuyé
// variable pour la mémoristion de mini joystck
int on_Joy_1; // position appuyé
int on_Joy_2; // position appuyé
int on_Joy_3; // position appuyé
int on_Joy_4; // position appuyé
// variable pour la mémoristion du centre
int cent_ana_1; // position appuyé
int cent_ana_2; // position appuyé
int cent_ana_3; // position appuyé
int cent_ana_4; // position appuyé
// variable pour la mémoristion du centre joystick
int cent_Joy_1; // position appuyé
int cent_Joy_2; // position appuyé
int cent_Joy_3; // position appuyé
int cent_Joy_4; // position appuyé
// variable pour la lecture des boutons
int inSensor1 = 0;        // valeur lu bnt 1
int inSensor2 = 0;        // valeur lu bnt 2
int inSensor3 = 0;        // valeur lu bnt 3
int inSensor4 = 0;        // valeur lu bnt 4
// variable pour la lecture des joystick
int inJoy1 = 0;        // valeur lu bnt 1
int inJoy2 = 0;        // valeur lu bnt 2
int inJoy3 = 0;        // valeur lu bnt 3
int inJoy4 = 0;        // valeur lu bnt 4
// variable transmises la lecture des boutons
int outSensor1 = 0;        // valeur transmise sortie 1 après convertion
int outSensor2 = 0;        // valeur transmise sortie 2 après convertion
int outSensor3 = 0;        // valeur transmise sortie 3 après convertion
int outSensor4 = 0;        // valeur transmise sortie 4 après convertion
// variable transmises la lecture joystick
int outJoy1 = 0;        // valeur transmise sortie 1 après convertion
int outJoy2 = 0;        // valeur transmise sortie 2 après convertion
int outJoy3 = 0;        // valeur transmise sortie 3 après convertion
int outJoy4 = 0;        // valeur transmise sortie 4 après convertion



// Variable etat joystick
bool m_av;
bool m_ar;
bool m_ga;
bool m_dr;

//Variables resultat de calcul 
int davar, dgadr;



// variables pour les options commandées par les broches 1,2,3,4,5
int inter_son = 1; // inter pour validez le son
int inter_btn_a = 2; // inter pour validez le bouton 1,2,3,4 avec les 4 boutons analogiques
int inter_btn_j = 3; // inter pour validez le bouton 5,6,7,8 avec les 4 positions du joystick
int inter_Bgrf_a = 4; // inter pour validez l'envoie des infos vers le bargraph des 4 boutons analogiques
int inter_Bgrf_j = 5; // inter pour validez l'envoie des infos vers le bargraph des 4 positions du joystick

//Variables de conversion
int mapSensor1    = 0;
int mapSensor2    = 0;
int mapSensor3    = 0;
int mapSensor4    = 0;

int mapJoy1       = 0;
int mapJoy2       = 0;
int mapJoy3       = 0;
int mapJoy4       = 0;


// variable memoire
bool fin    = false;
bool mem_vide;
bool mem_full;



PROGMEM const byte BEEPS_MAX = 8;
int beeps                 = BEEPS_MAX;
int buzzer                = 11; // sortie 2
int frequency[BEEPS_MAX]  = {523, 587, 659, 698, 784 , 880 , 988 , 1046 }; // do, re mi, fa, sol, la , si ,do
int pulse[BEEPS_MAX]      = {10, 20, 30, 40, 50, 60, 100 };
int pause[BEEPS_MAX]      = { 50, 50, 150, 150, 150, 150, 150 };

//variable pour la gestion du temps
unsigned long del_1_Preview = 0;
unsigned long del_2_Preview = 0;
unsigned long del_3_Preview = 0;
unsigned long del_4_Preview = 0;
unsigned long del_5_Preview = 0;
unsigned long del_6_Preview = 0;
unsigned long del_7_Preview = 0;
unsigned long del_8_Preview = 0;
int           t_interval    = 20;

//variable pour les boucle de mesure 
unsigned long mesure_Preview = 0;
int           int_mesure     = 2000;

// Bargraph
unsigned long del_1_Bargraph = 0;
int t_int_Bargraph           = 150;

// angle
static int angle=0;

// timing info
static long lastloop      = 0;
static boolean anyChange  = false;
static int XC             = 0;
static int YC             = 0;
static int X;
static int Y;
static int cnt            = 3;
