CLI_COMMAND(mulxFunc);
CLI_COMMAND(mulyFunc);
//CLI_COMMAND(ForceCommandFunc);
CLI_COMMAND(SaveFunc);
CLI_COMMAND(helpFunc);
CLI_COMMAND(connectFunc);

CLI_COMMAND(appuie_1);
CLI_COMMAND(appuie_2);
CLI_COMMAND(appuie_3);
CLI_COMMAND(appuie_4);
CLI_COMMAND(appuie_x);
CLI_COMMAND(appuie_y);
//
CLI_COMMAND(appuie_1) {
    if (argc == 1) {
        dev->print("Entrée 1 : ");
        dev->println(analogRead(ana_inPin1));
        return 0;
    }
      
    else if (argc == 2)
    {
        int mulx =  atoi (argv[1]);
        double val = 0;
//        switch mulx{
//          case 1:
//              dev->println("Appuyer btn1");          
//              delay(1000);
//              for(int x = 0 ; x < 100 ; x++){ 
//                val += analogRead(ana_inPin1);
//                dev->print("-");
//                delay(100);
//              } 
//              dev->println("");
//              val = val/100;
//              dev->println(val);
//              return (0);
//          case 2:
//          
//        }
 return (0);
}
}
//
CLI_COMMAND(appuie_2){
     dev->print("Entrée 2 : ");
     dev->println(analogRead(ana_inPin2));
  return (0);
}
CLI_COMMAND(appuie_3){
     dev->print("Entrée 3 : ");
     dev->println(analogRead(ana_inPin3));
  return (0);
}
CLI_COMMAND(appuie_4){
     dev->print("Entrée 4 : ");
     dev->println(analogRead(ana_inPin4));
  return (0);
}
CLI_COMMAND(appuie_x){
     dev->print("Entrée X : ");
     dev->println(analogRead(ana_inPin4));
  return (0);
}
CLI_COMMAND(appuie_y){
     dev->print("Entrée Y : ");
     dev->println(analogRead(ana_inPin4));
  return (0);
}

CLI_COMMAND(connectFunc) {
    dev->println("Configuration de la manette.");
    dev->println("Type 'aide' or '?' pour avoir une aide.");
    dev->print ("EEPROM MAGIC:");
    dev->println (get_eeprom_magic(), HEX);
    return (0);
}

static const char h1[] PROGMEM =  "aide or ? - affiche la liste des commandes";
static const char h2[] PROGMEM =  "mulx [1,32] set X multiplier";
static const char h3[] PROGMEM =  "muly [1,32] set Y multiplier";
static const char h4[] PROGMEM =  "bt1, bt2 bt3, bt4, x, yt - ajuste les positions maximales et minimales";
static const char h5[] PROGMEM =  "save  - save options in EEPROM";

CLI_COMMAND(helpFunc) {
    dev->println(h1);
    dev->println(h2);
    dev->println(h3);
    dev->println(h4);
    dev->println(h5);
    
    //dev->println("force  - force right/left command state");
   
    return 0;
}


CLI_COMMAND(mulxFunc) {
  
    if (argc == 1) {
        dev->print("mulx:");
        dev->println(get_mulx());
        return 0;
    }
      
    else if (argc == 2)
    {
        int mulx =  atoi (argv[1]);
        if (mulx > 0 && mulx < 33)
        {
          set_mulx (mulx);
       
          dev->print("mulx:");
          dev->println(get_mulx());
          return (0);
        }
        else
        {
            dev->println("Usage: mulx - display X multiplier");
            dev->println("Usage: mulx 8- set X multiplier to 8");
            return 10;
        }
    }
    else
    {
       dev->println("Usage: mulx - display X multiplier");
       dev->println("Usage: mulx 8- set X multiplier to 8");
        return 10;
    }
  return (0);
}

CLI_COMMAND(mulyFunc) {
  
    if (argc == 1) {
        dev->print("muly:");
        dev->println(get_muly());
        return 0;
    }  
    else if (argc == 2)
    {
        int muly = atoi (argv[1]);
        
        if (muly > 0 && muly < 33)
        {
          set_muly (muly);
          
          dev->print("muly:");
          dev->println(get_muly());
          return (0);
        }
        else
        {
            dev->println("Usage: muly - display Y multiplier");
            dev->println("Usage: muly 8- set Y multiplier to 8");
            return 10;
        }
    }
    else
    {
       dev->println("Usage: muly - display Y multiplier");
       dev->println("Usage: muly 8- set Y multiplier to 8");
        return 10;
    }
  return (0);
}


CLI_COMMAND(SaveFunc)
{
  if (argc != 1)
  {
      dev->println("Usage: save - Save EEPROM");
      return 10;
  }
  else
  {
    save_config ();
    dev->println("saved");
  }
  return (0);
}

void cli_open ()
{
    Serial.begin(9600);
    CLI.setDefaultPrompt("> ");
    CLI.onConnect(connectFunc);
    CLI.addCommand("aide", helpFunc);
    CLI.addCommand("?", helpFunc);    
    CLI.addCommand("mulx", mulxFunc);
    CLI.addCommand("muly", mulyFunc);
    CLI.addCommand("Save", SaveFunc);
    CLI.addCommand("bt1", appuie_1);
    CLI.addCommand("bt2", appuie_2);
    CLI.addCommand("bt3", appuie_3);
    CLI.addCommand("Bt3", appuie_4);
    CLI.addCommand("x", appuie_x);
    CLI.addCommand("y", appuie_y);
  
    CLI.addClient(Serial);
}

void cli_close ()
{
}


